/// Author: NemanjaSo2005
/// Date: 26th February 2023
/// Contest: Serbian high school regional contest
/// Anyone can use any part of this code for any purpose after the contest.
#include<bits/stdc++.h>
#define ll long long
using namespace std;
ll MOD=1e9+7;
ll N,X[1000005],Y[1000005],sx,sy,mx,my,res[1000005];
ll min(ll a,int b){
   if(a<b)
      return a;
   return b;
}
ll min(int a,ll b){
   if(a<b)
      return a;
   return b;
}
ll max(ll a,int b){
   if(a>b)
      return a;
   return b;
}
ll max(int a,ll b){
   if(a>b)
      return a;
   return b;
}
void calc(){
   mx=-1e9;
   my=-1e9;
   sx=0;
   sy=0;
   ll tmp=0;
   mx=X[1];
   my=Y[1];
   sx=X[1];
   sy=Y[1];
   for(int i=2;i<=N;i++){
      //cout<<i<<" "<<tmp<<endl;
      if(mx<X[i]){
         tmp+=(my*(i-1)-sy)*(X[i]-mx);
         //sx+=X[i];
         mx=X[i];
      }
     // cout<<mx<<" "<<sx<<" "<<tmp<<endl;
      if(my<Y[i]){
         tmp+=(mx*(i-1)-sx)*(Y[i]-my);
         //sy+=Y[i];
         my=Y[i];
      }
      //cout<<my<<" "<<sy<<" "<<tmp<<endl;
      tmp+=abs(mx-X[i])*abs(my-Y[i]);
      sx+=X[i];
      sy+=Y[i];
      //cout<<my<<" "<<sy<<" "<<tmp<<endl;
      res[i]=max(res[i],tmp);
   }
}
void solve(){
   cin>>N;
   for(int i=1;i<=N;i++)
      cin>>X[i]>>Y[i];
   calc();
   for(int i=1;i<=N;i++)
      Y[i]=-Y[i];
   calc();
   for(int i=1;i<=N;i++)
      X[i]=-X[i];
   calc();
   for(int i=1;i<=N;i++)
      Y[i]=-Y[i];
   calc();
   for(int i=1;i<=N;i++)
      cout<<res[i]%MOD<<"\n";
   cout<<endl;
}
void reset(){}
int main(){
   ios_base::sync_with_stdio(false);
   cin.tie(0);
   int T=1;
  // cin>>T;
   while(T--){
      solve();
      reset();
   }
   return 0;
}